/*
 File: lr1_k_phrase_th.h
 Date and Time: Fri Jan 30 18:55:15 2015 
*/
#ifndef __lr1_k_phrase_th_h__
#define __lr1_k_phrase_th_h__ 1
#include "yacco2.h"
#include "yacco2_T_enumeration.h"
#include "yacco2_k_symbols.h"
#include "yacco2_err_symbols.h"
#include "yacco2_terminals.h"
#include "yacco2_characters.h"

#include "lint_balls.h"
#include "identifier.h"
#include "term_def_ph.h"
#include "c_string.h"
#include "o2_sdc.h"
#include "cweb_or_c_k.h"
 
extern yacco2::Thread_entry ITH_lr1_k_phrase_th;

extern yacco2::State S1_Clr1_k_phrase_th;
namespace NS_lr1_k_phrase_th {
yacco2::THR _YACCO2_CALL_TYPE
TH_lr1_k_phrase_th(yacco2::Parser* Caller);// called thread
yacco2::THR_result _YACCO2_CALL_TYPE
PROC_TH_lr1_k_phrase_th(yacco2::Parser* Caller);// called thread's twin the procedure
using namespace NS_yacco2_T_enum;// enumerate
using namespace yacco2;
struct fsm_rules_reuse_table_type{
 fsm_rules_reuse_table_type();
 int no_rules_entries_;
 Per_rule_s_reuse_table* per_rule_s_table_[23];
};
class Clr1_k_phrase_th: public yacco2::CAbs_fsm {
 public:
  enum rules_and_subrules{
   start_of_rule_list = NS_yacco2_T_enum::T_Enum::sum_total_T
   ,R_Rlr1_k_phrase_ = 569//start_of_rule_list + 0
    ,rhs1_Rlr1_k_phrase_ = 1
   ,R_Ropen_par_ = 570//start_of_rule_list + 2
    ,rhs1_Ropen_par_ = 2
    ,rhs2_Ropen_par_ = 3
   ,R_Rclose_par_ = 571//start_of_rule_list + 4
    ,rhs1_Rclose_par_ = 4
    ,rhs2_Rclose_par_ = 5
   ,R_Rparameters_ = 572//start_of_rule_list + 6
    ,rhs1_Rparameters_ = 6
   ,R_Rfilename_phrase_ = 573//start_of_rule_list + 8
    ,rhs1_Rfilename_phrase_ = 7
   ,R_Rfilename_ = 574//start_of_rule_list + 10
    ,rhs1_Rfilename_ = 8
    ,rhs2_Rfilename_ = 9
    ,rhs3_Rfilename_ = 10
   ,R_Rfilename_id_ = 575//start_of_rule_list + 12
    ,rhs1_Rfilename_id_ = 11
    ,rhs2_Rfilename_id_ = 12
    ,rhs3_Rfilename_id_ = 13
   ,R_Rnamespace_phrase_ = 576//start_of_rule_list + 14
    ,rhs1_Rnamespace_phrase_ = 14
    ,rhs2_Rnamespace_phrase_ = 15
   ,R_Rnamespace_ = 577//start_of_rule_list + 16
    ,rhs1_Rnamespace_ = 16
    ,rhs2_Rnamespace_ = 17
    ,rhs3_Rnamespace_ = 18
   ,R_Rnamespace_id_ = 578//start_of_rule_list + 18
    ,rhs1_Rnamespace_id_ = 19
    ,rhs2_Rnamespace_id_ = 20
    ,rhs3_Rnamespace_id_ = 21
   ,R_Rsym_defs_phrase_ = 579//start_of_rule_list + 20
    ,rhs1_Rsym_defs_phrase_ = 22
   ,R_Rsym_def_ = 580//start_of_rule_list + 22
    ,rhs1_Rsym_def_ = 23
    ,rhs2_Rsym_def_ = 24
    ,rhs3_Rsym_def_ = 25
   ,R_Rsym_def1s_ = 581//start_of_rule_list + 24
    ,rhs1_Rsym_def1s_ = 26
    ,rhs2_Rsym_def1s_ = 27
    ,rhs3_Rsym_def1s_ = 28
   ,R_Rsym_def1_ = 582//start_of_rule_list + 26
    ,rhs1_Rsym_def1_ = 29
    ,rhs2_Rsym_def1_ = 30
    ,rhs3_Rsym_def1_ = 31
   ,R_Rt_sufx_phrase_ = 583//start_of_rule_list + 28
    ,rhs1_Rt_sufx_phrase_ = 32
    ,rhs2_Rt_sufx_phrase_ = 33
   ,R_Rt_sufx_kw_code_ = 584//start_of_rule_list + 30
    ,rhs1_Rt_sufx_kw_code_ = 34
    ,rhs2_Rt_sufx_kw_code_ = 35
   ,R_Rt_sufx_kw_ = 585//start_of_rule_list + 32
    ,rhs1_Rt_sufx_kw_ = 36
   ,R_Rt_sufx_kw_must_ = 586//start_of_rule_list + 34
    ,rhs1_Rt_sufx_kw_must_ = 37
    ,rhs2_Rt_sufx_kw_must_ = 38
    ,rhs3_Rt_sufx_kw_must_ = 39
   ,R_Rt_sufx_code_ = 587//start_of_rule_list + 36
    ,rhs1_Rt_sufx_code_ = 40
    ,rhs2_Rt_sufx_code_ = 41
    ,rhs3_Rt_sufx_code_ = 42
   ,R_Ropen_brace_ = 588//start_of_rule_list + 38
    ,rhs1_Ropen_brace_ = 43
    ,rhs2_Ropen_brace_ = 44
   ,R_Rclose_brace_ = 589//start_of_rule_list + 40
    ,rhs1_Rclose_brace_ = 45
    ,rhs2_Rclose_brace_ = 46
   ,R_Rlint_ = 590//start_of_rule_list + 42
    ,rhs1_Rlint_ = 47
    ,rhs2_Rlint_ = 48
   ,R_Rcweb_k_ = 591//start_of_rule_list + 44
    ,rhs1_Rcweb_k_ = 49
    ,rhs2_Rcweb_k_ = 50
  };
  //no of la sets = 12
  //no of states = 88
  Clr1_k_phrase_th();
  ~Clr1_k_phrase_th();
  void op();
  bool failed();
  void reduce_rhs_of_rule
      (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule);
  fsm_rules_reuse_table_type fsm_rules_reuse_table;
  static int rhs_to_rules_mapping_[51];
  
    public:
    T_lr1_k_phrase* lr1_k_phrase_;
  
 };
struct Rlr1_k_phrase;
struct Ropen_par;
struct Rclose_par;
struct Rparameters;
struct Rfilename_phrase;
struct Rfilename;
struct Rfilename_id;
struct Rnamespace_phrase;
struct Rnamespace;
struct Rnamespace_id;
struct Rsym_defs_phrase;
struct Rsym_def;
struct Rsym_def1s;
struct Rsym_def1;
struct Rt_sufx_phrase;
struct Rt_sufx_kw_code;
struct Rt_sufx_kw;
struct Rt_sufx_kw_must;
struct Rt_sufx_code;
struct Ropen_brace;
struct Rclose_brace;
struct Rlint;
struct Rcweb_k;
struct Rlr1_k_phrase:public yacco2::CAbs_lr1_sym {
  Rlr1_k_phrase(yacco2::Parser* P);
  public:
  void sr1();
};

struct Ropen_par:public yacco2::CAbs_lr1_sym {
  Ropen_par(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rclose_par:public yacco2::CAbs_lr1_sym {
  Rclose_par(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rparameters:public yacco2::CAbs_lr1_sym {
  Rparameters(yacco2::Parser* P);
  public:
};

struct Rfilename_phrase:public yacco2::CAbs_lr1_sym {
  Rfilename_phrase(yacco2::Parser* P);
  public:
};

struct Rfilename:public yacco2::CAbs_lr1_sym {
  Rfilename(yacco2::Parser* P);
  public:
  void sr2();
  void sr3();
};

struct Rfilename_id:public yacco2::CAbs_lr1_sym {
  Rfilename_id(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
};

struct Rnamespace_phrase:public yacco2::CAbs_lr1_sym {
  Rnamespace_phrase(yacco2::Parser* P);
  public:
  void sr2();
};

struct Rnamespace:public yacco2::CAbs_lr1_sym {
  Rnamespace(yacco2::Parser* P);
  public:
  void sr2();
  void sr3();
};

struct Rnamespace_id:public yacco2::CAbs_lr1_sym {
  Rnamespace_id(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
};

struct Rsym_defs_phrase:public yacco2::CAbs_lr1_sym {
  Rsym_defs_phrase(yacco2::Parser* P);
  public:
};

struct Rsym_def:public yacco2::CAbs_lr1_sym {
  Rsym_def(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
};

struct Rsym_def1s:public yacco2::CAbs_lr1_sym {
  Rsym_def1s(yacco2::Parser* P);
  public:
};

struct Rsym_def1:public yacco2::CAbs_lr1_sym {
  Rsym_def1(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
};

struct Rt_sufx_phrase:public yacco2::CAbs_lr1_sym {
  Rt_sufx_phrase(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rt_sufx_kw_code:public yacco2::CAbs_lr1_sym {
  Rt_sufx_kw_code(yacco2::Parser* P);
  public:
};

struct Rt_sufx_kw:public yacco2::CAbs_lr1_sym {
  Rt_sufx_kw(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rt_sufx_kw_must:public yacco2::CAbs_lr1_sym {
  Rt_sufx_kw_must(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
};

struct Rt_sufx_code:public yacco2::CAbs_lr1_sym {
  Rt_sufx_code(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
};

struct Ropen_brace:public yacco2::CAbs_lr1_sym {
  Ropen_brace(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rclose_brace:public yacco2::CAbs_lr1_sym {
  Rclose_brace(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rlint:public yacco2::CAbs_lr1_sym {
  Rlint(yacco2::Parser* P);
  public:
};

struct Rcweb_k:public yacco2::CAbs_lr1_sym {
  Rcweb_k(yacco2::Parser* P);
  void ctor();

	  AST* cweb_t_;
	
  public:
  void sr1();
  void sr2();
};

} // end of namespace

#endif
